
<template>
  <div>
    <primevue-datatable ref="mainTable" :lazy="true" :value="rows" :class="['tait-table', isNestedTable ? 'nested' : 'single', 'p-datatable-sm']" v-model:selection="selectedData"
                        :resizableColumns="true" :selectionMode="'multiple'" :columnResizeMode="'fit'" :scrollable="true" :stripedRows="true"
                        :totalRecords="totalRecords" @page="onPage($event)" @sort="onSort($event)" @filter="onFilter()"
                        :loading="loading" :showGridlines="true" :responsiveLayout="'scroll'" v-model:filters="filters" :filterDisplay="'row'"
                        :paginator="true" :rows="10" :rowsPerPageOptions="[10,20,50]">
      <template #empty>
        No rows to display.
      </template>

      <template #loading>
        Loading...
      </template>

      <template #header>
        <div style="text-align:left">
          <primevue-button icon="pi pi-refresh" class="p-button-raised" @click="loadLazyData" :loading="loading"/>
          <primevue-button @click="clearFilters" class="p-button-raised">Clear Filters</primevue-button>
          <primevue-multiselect :modelValue="selectedColumns" :options="columns" optionLabel="header" @update:modelValue="onToggle"
                                placeholder="Select Columns" style="width: 20em"></primevue-multiselect>
        </div>
      </template>

      <primevue-column v-for="(col, index) of selectedColumns" :field="col.field" :key="col.field + '_' + index"
                       :sortable="typeof col.sortable !== 'undefined' ? col.sortable : true">

        <template #header>
          <div v-tooltip.top="col.header">
            {{col.header}}
          </div>
        </template>

        <template #filter="{filterModel,filterCallback}">
          <primevue-inputtext v-if='col.type === "text"' type="text" v-model="filterModel.value" @keydown.enter="filterCallback()"
                              class="p-column-filter" placeholder="Search by text"></primevue-inputtext>
          <primevue-inputtext v-if='col.type === "secondsAsInt"' type="text" v-model="filterModel.value" @keydown.enter="filterCallback()"
                              class="p-column-filter" placeholder="Search by text"/>
          <primevue-dropdown v-if='col.type === "dropdown"' v-model="filterModel.value" @change="filterCallback()" :options="listAny(col.options || [])"
                             optionLabel="name" placeholder="(any)" class="p-column-filter"></primevue-dropdown>
          <primevue-dropdown v-if='col.type === "datePeriods"'  v-model="filterModel.value" @change="filterCallback()" :options="dateDropdown"
                             optionLabel="name" placeholder="(any)" class="p-column-filter"></primevue-dropdown>
          <primevue-calendar v-if='col.type === "date"' :showButtonBar="true" :showIcon="true" v-model="filterModel.value" :showSeconds="true"
                             @input="filterCallback()" @date-select="filterCallback()" @clear-click="filterCallback()" dateFormat="yy-mm-dd"
                             placeholder="yyyy-mm-dd" :showTime="true"></primevue-calendar>
          <primevue-multiselect v-if='col.type === "multiselect"' v-model="filterModel.value" @change="filterCallback()" :options="col.options"
                                placeholder="(any)" class="p-column-filter" display="chip"></primevue-multiselect>
        </template>

        <template #body="slotProps" v-if="col.selectable">
          <router-link :to="$route.path + '/' + slotProps['data'][editKey || col.field]" v-text="slotProps['data'][col.field]"/>
        </template>

      </primevue-column>

      <template #paginatorstart>
        <span class="tait-table-button">
            <primevue-button v-if="createMode" @click="createPage" class="p-button-raised" label="Create" icon="pi pi-plus"/>
            <primevue-button v-if="editKey && selectedData.length === 1" @click="editSelected" class="p-button-raised" label="Edit" icon="pi pi-pencil"/>
            <primevue-button v-if="deleteKey && selectedData.length > 0" @click="deleteSelected" class="p-button-raised"
                            :label="(selectedData.length === 1) ? 'Delete': 'Delete Many'" icon="pi pi-trash" :loading="deleting"/>
            <slot name="extraTableButtons" :tableButtonClass="'p-button-raised'">
              <!-- Slot for extra buttons -->
            </slot>
        </span>
      </template>

    </primevue-datatable>
    <span class="tait-table-button">
      <primevue-button v-if="createMode" @click="createPage" class="p-button-raised" label="Create" icon="pi pi-plus"/>
      <primevue-button v-if="editKey && selectedData.length === 1" @click="editSelected" class="p-button-raised" label="Edit" icon="pi pi-pencil"/>
      <primevue-button v-if="deleteKey && selectedData.length > 0" @click="deleteSelected" class="p-button-raised"
                       :label="(selectedData.length === 1) ? 'Delete': 'Delete Many'" icon="pi pi-trash" :loading="deleting"/>
      <slot name="extraTableButtons" :tableButtonClass="'p-button-raised'">
        <!-- Slot for extra buttons -->
      </slot>
    </span>
  </div>
</template>

<style scoped lang="scss">
// Stying for stand alone table
::v-deep(.tait-table.single) {
  .p-datatable-wrapper {
    height: 70vh;
  }

  .p-paginator-bottom {
    background-color: transparent;
    overflow: hidden;
    position: fixed;
    right: 0;
    bottom: 0;
    height: 58px;
    z-index: 1;
  }

  .tait-table-button {
    position: fixed;
    height: 47px;
    bottom: 0;
    left: 230px;
    z-index: 1;
  }
}

// Styling for nested tables for reusability  within other components
::v-deep(.tait-table.nested) {
  .p-datatable-wrapper {
    max-height: 35vh;
  }
}

// Shared styles
::v-deep(.tait-table.single),
::v-deep(.tait-table.nested) {
  position: relative;
  font-size: 12px;

  .p-button-raised,
  .p-button {
    border: none;
    background-color: #636c77;
    color: #e7e8e9;

    &:hover {
      background-color: #4a4f55;
      color: #ffffff;
    }
  }

  .p-datatable-thead {
    font-size: 14px;
  }

  .p-datatable-tbody {
    position: relative;
    overflow: overlay;
  }

  .p-button-raised {
    margin: 2px;
  }

  .p-column-filter-menu-button,
  .p-column-filter-clear-button {
    display: none;
  }

  .p-paginator {
    .p-paginator-element {
      color: #676f78;

      &:hover {
        background-color: #414b55 !important;
        color: #e7e8e9 !important;
      }
    }

    .p-paginator-pages .p-highlight {
      background-color: #676f78;
      color: #e7e8e9;
    }

    .p-disabled {
      visibility: hidden;
    }
  }
}
</style>

<script lang="ts">
import { FilterMatchMode } from "primevue/api";
import dataTableDef from "primevue/datatable";
import { defineComponent, PropType } from "vue";

import type { FieldType as ColumnType, DropdownType } from "@/types";

interface date {
  first: number;
  last: number;
}

interface dateColumn {
  name: string;
  code: date;
}

export default defineComponent({
  props: {
    columns: {
      type: Object as PropType<ColumnType[]>,
      required: true
    },
    url: {
      type: String,
      required: true
    },
    deleteKey: {
      type: String,
      default: ""
    },
    createMode: {
      type: Boolean,
      default: false
    },
    editKey: {
      type: String,
      default: ""
    },
    adminOnly: {
      type: Boolean,
      default: false
    },
    isNestedTable: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {
      loading: false,
      deleting: false,
      totalRecords: 0,
      selectedColumns: [] as ColumnType[],
      selectedData: [] as Record<string, string | number>[],
      pageNum: 0,
      lazyParams: {} as dataTableDef["$props"],
      filters: {} as Record<string, { value?: string; matchMode?: string; }>,
      rows: [],
      dateDropdown: [
        { name: "up to an hour ago", code: { "first": 0, "last": 60 } },
        { name: "1 - 2 hours ago", code: { "first": 60, "last": 120 } },
        { name: "2 - 4 hours ago", code: { "first": 120, "last": 240 } },
        { name: "4 - 8 hours ago", code: { "first": 240, "last": 480 } },
        { name: "8 - 12 hours ago", code: { "first": 480, "last": 720 } },
        { name: "12 - 24 hours ago", code: { "first": 720, "last": 1440 } },
        { name: "1 - 7 days ago", code: { "first": 1440, "last": 10080 } },
        { name: "more than a week ago", code: { "first": 10080, "last": 99999999 } }
      ],
      minuteToMilliseconds: 60000
    };
  },

  created() {
    for (let col in this.columns) {
      this.filters[this.columns[col].field] = {
        value: undefined,
        matchMode: FilterMatchMode.CONTAINS
      };
    }
    if (localStorage.getItem(`${this.url}-columns`)) {
      let cols = JSON.parse(localStorage.getItem(`${this.url}-columns`) as string);
      const target_copy = Object.assign({}, this.columns);
      for (let col in cols) {
        for (let column in target_copy) {
          if (cols[col].field === target_copy[column].field) {
            this.selectedColumns.push(target_copy[column]);
          }
        }
      }
    } else {
      this.selectedColumns = this.columns;
    }
    this.dateDropdown.unshift({ name: '(any)', code: { "first": 0, "last": 0 } });
    if (!this.isNestedTable) this.loadLazyData();
  },

  methods: {
    listAny(orgList: Array<DropdownType>) {
      if (orgList[0].name !== '(any)') {
        let add: DropdownType = { name: '(any)', value: -1 };
        orgList.unshift(add);
      }
      return orgList;
    },

    deleteSelected() {
      const params = new URLSearchParams();
      this.$toast.removeAllGroups();
      this.deleting = true;

      for (const toDelete of this.selectedData) {
        params.append(this.deleteKey, toDelete[this.deleteKey].toString());
      }

      // send back end request to delete

      this.deleting = false
    },

    createPage() {
      this.$router.push(this.url + "/create");
    },

    editSelected() {
      this.$router.push(this.url + "/" + this.selectedData[0][this.editKey]);
    },

    clearFilters() {
      for (let col in this.columns) {
        this.filters[this.columns[col].field] = { value: "", matchMode: FilterMatchMode.CONTAINS };
      }
      this.loadLazyData();
    },

    formatDate(date: string) {
      let d = new Date(date),
        month = "" + (d.getMonth() + 1),
        day = "" + d.getDate(),
        year = d.getFullYear(),
        hour = d.getHours(),
        minute = d.getMinutes(),
        second = d.getSeconds();
      if (month.length < 2) month = "0" + month;
      if (day.length < 2) day = "0" + day;

      return [year, month, day].join('-') + " " + [hour, minute, second].join(':');
    },

    onToggle(value: ColumnType[]) {
      this.selectedColumns = this.columns.filter(col => value.includes(col));
      localStorage.setItem(`${this.url}-columns`, JSON.stringify(this.selectedColumns));
      this.loadLazyData();
    },

    // eslint-disable-next-line
    instanceOfDropdownColumn(object: any): object is DropdownType {
      if (typeof object === "string") {
        return false;
      } else {
        return 'value' in object;
      }
    },

    // eslint-disable-next-line
    instanceOfDateColumn(object: any): object is dateColumn {
      if (typeof object === "string") {
        return false;
      } else {
        return 'code' in object;
      }
    },

    loadLazyData() {
      this.loading = true;

      let descend = "true";
      if (this.lazyParams.sortOrder === -1) {
        descend = "false";
      }

      const params = new URLSearchParams();
      params.append("page_size", `${this.lazyParams.rows || 10}`);
      params.append("page_num", `${Math.round((this.lazyParams.first || this.pageNum) / (this.lazyParams.rows || 10)) + 1}`);
      params.append("sort_key", this.lazyParams.sortField as string || "id");
      params.append("descend", descend);

      for (const property in this.lazyParams.filters) {
        if ([undefined, "", "(any)"].includes(this.lazyParams.filters[property].value)
          || this.selectedColumns.filter(function (e) { return e.field === property; }).length == 0
          || this.lazyParams.filters[property].value.name == "(any)")
          continue;

        if (this.lazyParams.filters[property].value instanceof Date) {
          params.append(property, this.formatDate(this.lazyParams.filters[property].value));
        } else if (property === "agencyName") {
          (this.lazyParams.filters[property].value as string[]).forEach(agt => { params.append(property, agt); });
        } else if (this.instanceOfDateColumn(this.lazyParams.filters[property].value)) {
          let now = new Date();
          let first = new Date(now.getTime() - this.lazyParams.filters[property].value.code.first * this.minuteToMilliseconds);
          let last = new Date(now.getTime() - this.lazyParams.filters[property].value.code.last * this.minuteToMilliseconds);
          params.append(property + "First", `${first.getTime()}`);
          params.append(property + "Last", `${last.getTime()}`);
        } else if (this.instanceOfDropdownColumn(this.lazyParams.filters[property].value)) {
          params.append(property, `${this.lazyParams.filters[property].value.value}`);
        } else {
          params.append(property, `${this.lazyParams.filters[property].value}`);
        }
      }

      // Backend request to get data
      const secAsIntToTransform = this.columns.filter(col => col.type === "secondsAsInt");

      let rows : any = [{"id":103040,"suid":"A43972CC00006D","wuid":"00006D","alias":"PacketData","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null},
                  {"id":103039,"suid":"A43972CC00006C","wuid":"00006C","alias":"PacketData","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null},
                  {"id":103038,"suid":"A43972CC00006B","wuid":"00006B","alias":"PacketData","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null},
                  {"id":103037,"suid":"A43972CC00006A","wuid":"00006A","alias":"PacketData","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null},
                  {"id":103036,"suid":"A43972CC000069","wuid":"000069","alias":"PacketData","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null},
                  {"id":103035,"suid":"A43972CC000068","wuid":"000068","alias":"PacketData","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null},
                  {"id":103034,"suid":"A43972CC000067","wuid":"000067","alias":"PacketData","vocoderMode":2,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":1,"locationId":"00033.D6.2CC.A4397.p25dr","locationAlias":"LoadTest18","locationType":5,"lastRegistration":"2021-07-12T23:59:20+12:00","expires":86401,"inhibited":0,"priority":5,"ipPool":"TestHome"},
                  {"id":103033,"suid":"A43972CC000066","wuid":"000066","alias":"PacketData","vocoderMode":2,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":1,"locationId":"00033.D6.2CC.A4397.p25dr","locationAlias":"LoadTest18","locationType":5,"lastRegistration":"2021-07-12T23:59:19+12:00","expires":86401,"inhibited":0,"priority":5,"ipPool":"TestHome"},
                  {"id":103032,"suid":"A43972CC000065","wuid":"000065","alias":"PacketData","vocoderMode":2,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":1,"locationId":"00033.D6.2CC.A4397.p25dr","locationAlias":"LoadTest18","locationType":5,"lastRegistration":"2021-07-12T23:59:23+12:00","expires":86401,"inhibited":0,"priority":5,"ipPool":"TestHome"},
                  {"id":103031,"suid":"A43972CC0286a0","wuid":"0286a0","alias":"DbFillSU165536","vocoderMode":3,"type":0,"agencyName":"Fleet0","serviceArea":"","visitor":0,"status":0,"locationId":"","locationAlias":null,"locationType":null,"lastRegistration":null,"expires":0,"inhibited":0,"priority":5,"ipPool":null}]

      for (const row in rows) {
        const result = this.columns.filter(obj => {
          return obj.type === "dropdown" &&
            (typeof rows[row][obj.field] === 'number' || typeof rows[row][obj.field] === 'string');
        });
        for (const dropdown in result) {
          const newText = (result[dropdown].options || []).filter(obj => {
            return obj.value === rows[row][result[dropdown].field];
          });
          rows[row][result[dropdown].field] = newText[0].name;
        }

        for (const secToTransform of secAsIntToTransform) {
          // transform the seconds stored as integers in the db to decimal representation.
          // i.e 25 in the db corresponds to 2.5 seconds, 100 is 10.0 seconds and so forth
          const currentValue = rows[row][secToTransform.field];
          if (typeof currentValue === "number") {
            rows[row][secToTransform.field] = `${(currentValue / 10).toFixed(1)}`;
          }
        }
      }
      this.rows = rows;
      this.totalRecords = 10;

      this.loading = false;
    },

    onPage(event: dataTableDef["$props"]) {
      this.lazyParams = event;
      this.pageNum = this.lazyParams.first || 0;
      this.loadLazyData();
    },

    onSort(event: dataTableDef["$props"]) {
      this.lazyParams = event;
      this.lazyParams.first = this.pageNum;
      this.loadLazyData();
      // eslint-disable-next-line
      (this.$refs.mainTable as any)._.data.d_first = this.pageNum;
    },

    onFilter() {
      this.lazyParams.filters = this.filters;
      this.lazyParams.first = 0;
      this.pageNum = 0;
      this.loadLazyData();
    }
  }
});
</script>

